diff --git a/game/core/src/main/java/net/minecraft/core/item/IFood.java b/game/core/src/main/java/net/minecraft/core/item/IFood.java
new file mode 100644
index 000000000..14cce954e
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/IFood.java
@@ -0,0 +1,10 @@
+package net.minecraft.core.item;
+
+public interface IFood {
+
+    int getHealAmount();
+
+    int getTicksPerHeal();
+
+    boolean getIsWolfsFavoriteMeat();
+}
diff --git a/game/core/src/main/java/net/minecraft/core/item/IItemContainer.java b/game/core/src/main/java/net/minecraft/core/item/IItemContainer.java
new file mode 100644
index 000000000..377480961
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/IItemContainer.java
@@ -0,0 +1,9 @@
+package net.minecraft.core.item;
+
+public interface IItemContainer {
+
+    boolean hasContainerItem(ItemStack stack);
+
+    ItemStack getContainerItemStack(ItemStack stack);
+
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
index 9418e8ead..cd66d85aa 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucket.java
@@ -1,98 +1,493 @@
 package net.minecraft.core.item;
 
-import net.minecraft.core.block.entity.TileEntityActivator;
-import net.minecraft.core.util.helper.Direction;
-import net.minecraft.core.util.phys.HitResult;
+import com.mojang.nbt.tags.CompoundTag;
 import net.minecraft.core.block.Block;
+import net.minecraft.core.block.BlockLogicFluid;
 import net.minecraft.core.block.Blocks;
+import net.minecraft.core.block.entity.TileEntityActivator;
+import net.minecraft.core.block.material.Materials;
 import net.minecraft.core.block.tag.BlockTags;
+import net.minecraft.core.entity.animal.MobCow;
 import net.minecraft.core.entity.player.Player;
 import net.minecraft.core.enums.EnumDropCause;
 import net.minecraft.core.sound.SoundCategory;
+import net.minecraft.core.util.HardIllegalArgumentException;
+import net.minecraft.core.util.collection.NamespaceID;
+import net.minecraft.core.util.helper.Direction;
 import net.minecraft.core.util.helper.Side;
-import net.minecraft.core.world.Dimension;
+import net.minecraft.core.util.phys.AABB;
+import net.minecraft.core.util.phys.HitResult;
 import net.minecraft.core.world.World;
-import net.minecraft.core.world.biome.Biome;
-import net.minecraft.core.world.biome.BiomeTags;
 import net.minecraft.core.world.pos.TilePos;
 import net.minecraft.core.world.pos.TilePosc;
 import org.jetbrains.annotations.NotNull;
 import org.jetbrains.annotations.Nullable;
+import org.joml.primitives.AABBd;
+import org.joml.primitives.AABBdc;
+
+import java.util.*;
+
+public abstract class ItemBucket extends ItemFood implements IItemContainer {
+
+    public record BucketState(
+            String name,
+            boolean isEdible,
+            int healAmount,
+            int ticksPerHeal,
+            @Nullable Block<?> fluidBlock,
+            boolean canPlace
+    ) {
+
+
+        /**
+         * Constructor for Food/Edible Buckets
+         */
+        public BucketState(String name, int healAmount, int ticksPerHeal) {
+            this(name, true, healAmount, ticksPerHeal, null, false);
+        }
+        /**
+         * Constructor for Fluid Buckets
+         */
+        public BucketState(String name, @Nullable Block<?> fluidBlock, boolean canPlace) {
+            this(name, false, 0, 0, fluidBlock, canPlace);
+        }
+    }
+
+    private static final Map<NamespaceID, BucketState> STATE_REGISTRY = new LinkedHashMap<>();
+    public static final NamespaceID STATE_EMPTY = new NamespaceID("minecraft", "empty");
+    public static final NamespaceID STATE_WATER = new NamespaceID("minecraft", "water");
+    public static final NamespaceID STATE_LAVA  = new NamespaceID("minecraft", "lava");
+    public static final NamespaceID STATE_MILK  = new NamespaceID("minecraft", "milk");
+    public static final NamespaceID STATE_ICECREAM = new NamespaceID("minecraft", "icecream");
+
+    static {
+        registerState(STATE_EMPTY, new BucketState("empty", null, false));
+        registerState(STATE_WATER, new BucketState("water", Blocks.FLUID_WATER_FLOWING, true));
+        registerState(STATE_LAVA, new BucketState("lava", Blocks.FLUID_LAVA_FLOWING, true));
+        registerState(STATE_MILK, new BucketState("milk", 0, 0));
+        registerState(STATE_ICECREAM, new BucketState("icecream", 15, 4));
+    }
+
+    public static NamespaceID registerState(NamespaceID id, BucketState state) {
+        if (STATE_REGISTRY.containsKey(id)) {
+            throw new IllegalArgumentException("Bucket state '" + id + "' is already registered!");
+        }
+        STATE_REGISTRY.put(id, state);
+        return id;
+    }
+
+    public static BucketState getBucketState(NamespaceID id) {
+        if (id == null || !STATE_REGISTRY.containsKey(id)) {
+            return STATE_REGISTRY.get(STATE_EMPTY);
+        }
+        return STATE_REGISTRY.get(id);
+    }
+
+    public static String getStateName(NamespaceID id) {
+        return id.value();
+    }
+
+    public static Set<NamespaceID> getRegisteredStateIds() {
+        return STATE_REGISTRY.keySet();
+    }
 
-import java.util.Random;
+    public static boolean isFluid(NamespaceID id) { return getBucketState(id).fluidBlock() != null; }
+    public static boolean isEdible(NamespaceID id) { return getBucketState(id).isEdible(); }
+    public static int getMaxStates() { return STATE_REGISTRY.size(); }
 
-public class ItemBucket extends Item {
-    private final @Nullable Block<?> blockToPlace;
+    @Override
+    public int getHealAmount(ItemStack stack) {return getBucketState(getState(stack)).healAmount();}
+    @Override
+    public int getTicksPerHeal(ItemStack stack) {return getBucketState(getState(stack)).ticksPerHeal();}
+
+    @Nullable
+    private NamespaceID getFluidStateAt(World world, TilePosc tilePos) {
+        if (world.getBlockMaterial(tilePos) == Materials.WATER) return STATE_WATER;
+        if (world.getBlockMaterial(tilePos) == Materials.LAVA) return STATE_LAVA;
+        return null;
+    }
+
+    public final int maxCharges;
 
-    public ItemBucket(@NotNull String name, @NotNull String namespaceId, int id, @Nullable Block<?> blockToPlace) {
-        super(name, namespaceId, id);
-        this.maxStackSize = 1;
-        this.blockToPlace = blockToPlace;
+    public ItemBucket(@NotNull String name, @NotNull String namespaceId, int id, int maxCharges) {
+        super(name, namespaceId, id, 0, 0, false, 64);
+        this.maxCharges = maxCharges;
+        this.maxStackSize = 64;
     }
 
     @Override
-    public @Nullable ItemStack onUse(@NotNull ItemStack selfStack, @NotNull World world, @NotNull Player player) {
-        if (this.blockToPlace == null) {
-            // Milk
-            return new ItemStack(Items.BUCKET);
+    public @NotNull String getLanguageKey(@NotNull ItemStack itemStack){
+        NamespaceID state = getState(itemStack);
+        if (STATE_EMPTY.equals(state)) return super.getKey();
+        return super.getKey() + "." + getStateName(state).replace("_", "");
+    }
+
+    @Override
+    public ItemStack onUse(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player) {
+        NamespaceID currentStateId = getState(itemStack);
+        BucketState currentState = getBucketState(currentStateId);
+
+        if (currentState.isEdible() && !currentState.canPlace()) {
+            return handleAirClick(itemStack, world, player);
         }
 
         double reachDistance = player.getGamemode().getBlockReachDistance();
-        HitResult rayCast = player.rayCast(reachDistance, 1f, false, false, false);
+        HitResult hitResultFluid = player.rayCast(reachDistance, 1f, true, false, false);
+        HitResult hitResultNoFluid = player.rayCast(reachDistance, 1f, false, false, false);
 
-        if (!(rayCast instanceof HitResult.Tile hitTile)) {
-            return selfStack;
+        if (hitResultFluid == null) {
+            return handleAirClick(itemStack, world, player);
+        } else if (hitResultFluid instanceof HitResult.Entity) {
+            return handleEntityClick(itemStack, world, player);
+        } else if (hitResultFluid instanceof HitResult.Tile hitTileFluid) {
+            TilePosc tilePos = hitTileFluid.tilePos;
+            boolean isSourceBlock = world.getBlockData(tilePos) == 0;
+
+            if (isSourceBlock) {
+                NamespaceID targetStateId = getFluidStateAt(world, tilePos);
+
+                boolean isEmptyScoop = STATE_EMPTY.equals(currentStateId);
+                boolean isRefillScoop = currentStateId.equals(targetStateId) && getCharges(itemStack) < this.maxCharges;
+
+                if (targetStateId != null && (isEmptyScoop || isRefillScoop)) {
+                    return tryPickupFluid(itemStack, world, player, tilePos, targetStateId);
+                }
+            }
+
+            if (currentState.canPlace() && hitResultNoFluid instanceof HitResult.Tile hitTileNoFluid) {
+                return tryPlaceFluid(itemStack, world, player, hitTileNoFluid);
+            }
         }
 
-        TilePos rayCastPos = new TilePos(hitTile.tilePos);
-        if (!world.canMineBlock(player, rayCastPos)) {
-            return selfStack;
+        return handleAirClick(itemStack, world, player);
+    }
+
+    protected ItemStack tryPickupFluid(ItemStack itemStack, World world, Player player, TilePosc tilePos, NamespaceID targetState) {
+        if (!world.canMineBlock(player, tilePos)) return itemStack;
+
+        world.setBlockTypeNotify(tilePos, Blocks.AIR);
+        player.swingItem();
+        world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, tilePos.x() + 0.5F, tilePos.y() + 0.5F, tilePos.z() + 0.5F, "item.pickup", 2.2f, 0.5f);
+
+        if (itemStack.stackSize > 1) {
+            return splitBucket(itemStack, player, targetState, world);
+        } else {
+            NamespaceID currentState = getState(itemStack);
+            if (STATE_EMPTY.equals(currentState)) {
+                setState(itemStack, targetState);
+                setCharges(itemStack, 1);
+            } else {
+                setCharges(itemStack, getCharges(itemStack) + 1);
+            }
+            return itemStack;
         }
+    }
 
-        Block<?> block = world.getBlockType(rayCastPos);
-        if (!block.hasTag(BlockTags.PLACE_OVERWRITES) && !block.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
+    protected ItemStack tryPlaceFluid(ItemStack itemStack, World world, Player player, HitResult.Tile hitTile) {
+        TilePos rayCastPos = new TilePos(hitTile.tilePos);
+        if (!world.canMineBlock(player, rayCastPos)) return itemStack;
+
+        Block<?> blockAtPos = world.getBlockType(rayCastPos);
+        if (!blockAtPos.hasTag(BlockTags.PLACE_OVERWRITES) && !blockAtPos.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
             Side side = hitTile.side;
             rayCastPos.x += side.getOffsetX();
             rayCastPos.y += side.getOffsetY();
             rayCastPos.z += side.getOffsetZ();
         }
 
-        if (rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) {
-            return selfStack;
-        }
+        if (rayCastPos.y < 0 || rayCastPos.y >= world.getHeightBlocks()) return itemStack;
 
         if (world.isAirBlock(rayCastPos) || !world.getBlockMaterial(rayCastPos).isSolid()) {
-            if (this.blockToPlace == Blocks.FLUID_WATER_FLOWING) {
-                world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.splash", 0.5f, 1.0f);
+            NamespaceID stateId = getState(itemStack);
+            BucketState bucketState = getBucketState(stateId);
+
+            if (bucketState.fluidBlock() != null) {
+
+                if(STATE_LAVA.equals(stateId)){
+                    BlockLogicFluid.fizz(world, rayCastPos);
+                    world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.lavapop", 1f, 1f);
+                }
+                if(STATE_WATER.equals(stateId)){
+                    world.playSoundEffect(player, SoundCategory.WORLD_SOUNDS, rayCastPos.x + 0.5F, rayCastPos.y + 0.5F, rayCastPos.z + 0.5F, "liquid.splash", 0.65f, 1f);
+                }
+
+                final Block<?> replacedBlock = world.getBlockType(rayCastPos);
+                final int replacedData = world.getBlockData(rayCastPos);
+
+                world.setBlockTypeNotify(rayCastPos, bucketState.fluidBlock());
+                replacedBlock.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, replacedData, null, null);
+
+                player.swingItem();
+
+                if (player.getGamemode().hasBlockConsumption()) {
+                    setCharges(itemStack, getCharges(itemStack) - 1);
+                    if (getCharges(itemStack) == 0) setState(itemStack, STATE_EMPTY);
+                }
             }
-            final var replacedBlock = world.getBlockType(rayCastPos);
-            final var replacedMeta = world.getBlockData(rayCastPos);
-            world.setBlockTypeNotify(rayCastPos, this.blockToPlace);
-            replacedBlock.dropWithCause(world, EnumDropCause.WORLD, rayCastPos, replacedMeta, null, null);
-                // is this being called afterwards intentional? 
-
-            player.swingItem();
-            if (player.getGamemode().hasBlockConsumption()) {
-                return new ItemStack(Items.BUCKET);
+        }
+        return itemStack;
+    }
+
+    protected ItemStack handleAirClick(ItemStack itemStack, World world, Player player) {
+        NamespaceID state = getState(itemStack);
+        if (isEdible(state)) {
+            return handleEdibleConsumption(itemStack, world, player);
+        }
+        return itemStack;
+    }
+
+    protected ItemStack handleEntityClick(ItemStack itemStack, World world, Player player) {
+        return handleAirClick(itemStack, world, player);
+    }
+
+    protected ItemStack handleEdibleConsumption(@NotNull ItemStack itemStack, @NotNull World world, @NotNull Player player) {
+        NamespaceID state = getState(itemStack);
+        BucketState bucketState = getBucketState(state);
+
+        if (player.getHealth() < player.getMaxHealth() || STATE_MILK.equals(state)) {
+            player.eatFood(itemStack);
+            String sound = bucketState.ticksPerHeal() >= 10 ? "random.bite_extended" : "random.bite";
+            world.playSoundAtEntity(player, player, sound, 0.5f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f, 1.1f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f);
+
+            if (itemStack.stackSize == 1) {
+                return this.getContainerItemStack(itemStack);
+            } else {
+                itemStack.stackSize--;
+                ItemStack container = this.getContainerItemStack(itemStack);
+                player.inventory.insertItem(container, true);
             }
         }
+        return itemStack;
+    }
+
+    public static void useBucket(ItemStack itemStack, Player player, World world, NamespaceID targetState) {
+        boolean isStacked = itemStack.stackSize > 1;
+        NamespaceID currentState = getState(itemStack);
+
+        int limit = (itemStack.getItem() instanceof ItemBucket bucket) ? bucket.maxCharges : 1;
 
-        return selfStack;
+        if (STATE_EMPTY.equals(currentState) || (currentState.equals(targetState) && getCharges(itemStack) < limit)) {
+            if (!isStacked) {
+                if (STATE_EMPTY.equals(currentState)) {
+                    setState(itemStack, targetState);
+                }
+                setCharges(itemStack, getCharges(itemStack) + 1);
+            } else {
+                splitBucket(itemStack, player, targetState, world);
+            }
+        }
+    }
+
+    protected static ItemStack splitBucket(@NotNull ItemStack itemStack, @NotNull Player player, NamespaceID state, @NotNull World world) {
+        itemStack.stackSize--;
+        ItemStack splitItemStack = new ItemStack(itemStack.getItem(), 1);
+        setState(splitItemStack, state);
+        setCharges(splitItemStack, 1);
+
+        player.inventory.insertItem(splitItemStack, true);
+        if (splitItemStack.stackSize > 0) {
+            world.dropItem((int) player.x, (int) player.y, (int) player.z, splitItemStack);
+        }
+        return itemStack;
+    }
+
+    public static int getCharges(@NotNull ItemStack stack) {
+        return stack.getData().getIntegerOrDefault("Charges", 0);
+    }
+
+    public static void setCharges(@NotNull ItemStack stack, int charges) {
+        CompoundTag tag = stack.getData();
+        if (charges <= 0) {
+            tag.getValue().remove("State");
+            tag.getValue().remove("Charges");
+        } else {
+            tag.putInt("Charges", charges);
+        }
+    }
+
+    public static NamespaceID getState(@NotNull ItemStack stack) {
+        CompoundTag tag = stack.getData();
+        if (tag.containsKey("State")) {
+            String stateStr = tag.getString("State");
+            if (stateStr.contains(":")) {
+                try {
+                    return new NamespaceID(stateStr);
+                } catch (HardIllegalArgumentException ignored) {
+                }
+            }
+        }
+        return STATE_EMPTY;
+    }
+
+    public static void setState(@NotNull ItemStack stack, NamespaceID state) {
+        CompoundTag tag = stack.getData();
+        if (state == null || STATE_EMPTY.equals(state)) {
+            tag.getValue().remove("State");
+            tag.getValue().remove("Charges");
+        } else {
+            tag.putString("State", state.toString());
+        }
     }
 
     @Override
-    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
-        if (this.blockToPlace == null) {
-            selfStack.itemID = Items.BUCKET.id;
-            return;
+    public int getItemStackLimit(@Nullable ItemStack itemStack) {
+        return (itemStack == null || STATE_EMPTY.equals(getState(itemStack))) ? 64 : 1;
+    }
+
+    @Override
+    public boolean hasContainerItem(ItemStack stack) {
+        return true;
+    }
+
+    @Override
+    public ItemStack getContainerItemStack(ItemStack stack) {
+        ItemStack leftover = stack.copy();
+        leftover.stackSize = 1;
+
+        int currentCharges = getCharges(leftover);
+        if (currentCharges > 1) {
+            setCharges(leftover, currentCharges - 1);
+        } else {
+            setState(leftover, STATE_EMPTY);
         }
+
+        return leftover;
+    }
+
+    public static ItemStack createItemStack(Item type, NamespaceID state, int charges) {
+        ItemStack stack = new ItemStack(type);
+        setState(stack, state);
+        setCharges(stack, charges);
+        return stack;
+    }
+
+    public static ItemStack createRecipeInput(Item type, NamespaceID state) {
+        ItemStack stack = new ItemStack(type);
+        setState(stack, state);
+        return stack;
+    }
+
+    @Override
+    public void onUseByActivator(@NotNull ItemStack selfStack, @NotNull World world, @NotNull TileEntityActivator activator, @NotNull Random random, @NotNull TilePosc blockPos, @NotNull Direction direction, double offX, double offY, double offZ) {
+        NamespaceID currentStateId = getState(selfStack);
+        BucketState currentState = getBucketState(currentStateId);
+
         TilePos posAhead = blockPos.add(direction, new TilePos());
-        Block<?> b = world.getBlockType(posAhead);
-        if (b.hasTag(BlockTags.PLACE_OVERWRITES) || b.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
-            world.setBlockTypeNotify(posAhead, this.blockToPlace);
-            world.getBlockType(posAhead).dropWithCause(world, EnumDropCause.WORLD, posAhead, world.getBlockData(posAhead), null, null);
+        Block<?> blockAhead = world.getBlockType(posAhead);
+
+        boolean isEmptyScoop = STATE_EMPTY.equals(currentStateId);
+        boolean isMilkScoop = STATE_MILK.equals(currentStateId) && getCharges(selfStack) < this.maxCharges;
+
+        if (isEmptyScoop || isMilkScoop) {
+            AABBd cowArea = new AABBd(posAhead.x, posAhead.y, posAhead.z, posAhead.x + 1, posAhead.y + 1, posAhead.z + 1);
+            List<MobCow> cows = world.getEntitiesWithinAABB(MobCow.class, cowArea);
+
+            if (!cows.isEmpty()) {
+                if (selfStack.stackSize > 1 && !canActivatorAccept(activator, selfStack.getItem(), STATE_MILK)) {
+                    return;
+                }
+
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, posAhead.x + 0.5F, posAhead.y + 0.5F, posAhead.z + 0.5F, "item.pickup", 2.2f, 0.5f);
+                handleActivatorFill(selfStack, STATE_MILK, activator);
+                return;
+            }
+        }
+
+        boolean isSourceBlock = world.getBlockData(posAhead) == 0;
+        if (isSourceBlock) {
+            NamespaceID targetStateId = getFluidStateAt(world, posAhead);
+            boolean isRefillScoop = currentStateId.equals(targetStateId) && getCharges(selfStack) < this.maxCharges;
+
+            if (targetStateId != null && (isEmptyScoop || isRefillScoop)) {
+                if (selfStack.stackSize > 1 && !canActivatorAccept(activator, selfStack.getItem(), targetStateId)) {
+                    return;
+                }
 
-            selfStack.itemID = Items.BUCKET.id;
+                world.setBlockTypeNotify(posAhead, Blocks.AIR);
+                world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, posAhead.x + 0.5F, posAhead.y + 0.5F, posAhead.z + 0.5F, "item.pickup", 2.2f, 0.5f);
+
+                handleActivatorFill(selfStack, targetStateId, activator);
+                return;
+            }
+        }
+
+        if (currentState.canPlace() && currentState.fluidBlock() != null) {
+            if (blockAhead.hasTag(BlockTags.PLACE_OVERWRITES) || blockAhead.hasTag(BlockTags.BROKEN_BY_FLUIDS)) {
+
+                if (STATE_LAVA.equals(currentStateId)) {
+                    BlockLogicFluid.fizz(world, posAhead);
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, posAhead.x + 0.5F, posAhead.y + 0.5F, posAhead.z + 0.5F, "liquid.lavapop", 1f, 1f);
+                } else if (STATE_WATER.equals(currentStateId)) {
+                    world.playSoundEffect(null, SoundCategory.WORLD_SOUNDS, posAhead.x + 0.5F, posAhead.y + 0.5F, posAhead.z + 0.5F, "liquid.splash", 0.65f, 1f);
+                }
+
+                int replacedData = world.getBlockData(posAhead);
+                world.setBlockTypeNotify(posAhead, currentState.fluidBlock());
+                blockAhead.dropWithCause(world, EnumDropCause.WORLD, posAhead, replacedData, null, null);
+
+                setCharges(selfStack, getCharges(selfStack) - 1);
+                if (getCharges(selfStack) == 0) {
+                    setState(selfStack, STATE_EMPTY);
+                }
+            }
+        }
+    }
+
+    /**
+     * Handles stack splitting and filling for the activator.
+     * Assumes inventory space has already been verified via canActivatorAccept.
+     */
+    private void handleActivatorFill(ItemStack selfStack, NamespaceID targetStateId, TileEntityActivator activator) {
+        NamespaceID currentStateId = getState(selfStack);
+
+        if (selfStack.stackSize > 1) {
+            selfStack.stackSize--;
+
+            ItemStack filledBucket = new ItemStack(selfStack.getItem(), 1);
+            setState(filledBucket, targetStateId);
+            setCharges(filledBucket, 1);
+
+            for (int i = 0; i < activator.getContainerSize(); i++) {
+                if (activator.locked(i)) continue;
+
+                ItemStack slotStack = activator.getItem(i);
+
+                if (slotStack == null) {
+                    activator.setItem(i, filledBucket);
+                    break;
+                }
+                else if (slotStack.itemID == filledBucket.itemID && getState(slotStack).equals(getState(filledBucket)) && slotStack.stackSize < slotStack.getMaxStackSize()) {
+                    slotStack.stackSize++;
+                    break;
+                }
+            }
+        } else {
+            if (STATE_EMPTY.equals(currentStateId)) {
+                setState(selfStack, targetStateId);
+                setCharges(selfStack, 1);
+            } else {
+                setCharges(selfStack, getCharges(selfStack) + 1);
+            }
+        }
+    }
+
+    /**
+     * Checks if the activator has a valid, unlocked slot to accept the specified filled bucket.
+     */
+    private boolean canActivatorAccept(TileEntityActivator activator, Item item, NamespaceID targetState) {
+        for (int i = 0; i < activator.getContainerSize(); i++) {
+            if (activator.locked(i)) continue;
+
+            ItemStack slotStack = activator.getItem(i);
+
+            if (slotStack == null) {
+                return true;
+            }
+
+            if (slotStack.itemID == item.id && getState(slotStack).equals(targetState) && slotStack.stackSize < slotStack.getMaxStackSize()) {
+                return true;
+            }
         }
+        return false;
     }
-}
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketIron.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketIron.java
new file mode 100644
index 000000000..95905d071
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketIron.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.item;
+
+import org.jetbrains.annotations.NotNull;
+
+public class ItemBucketIron extends ItemBucket {
+
+    public static final int MAX_CHARGES = 1;
+
+    public ItemBucketIron(@NotNull String name, @NotNull String namespaceId, int id) {
+        super(name, namespaceId, id, MAX_CHARGES);
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemBucketSteel.java b/game/core/src/main/java/net/minecraft/core/item/ItemBucketSteel.java
new file mode 100644
index 000000000..11b5e8032
--- /dev/null
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemBucketSteel.java
@@ -0,0 +1,12 @@
+package net.minecraft.core.item;
+
+import org.jetbrains.annotations.NotNull;
+
+public class ItemBucketSteel extends ItemBucket {
+
+    public static final int MAX_CHARGES = 3;
+
+    public ItemBucketSteel(@NotNull String name, @NotNull String namespaceId, int id) {
+        super(name, namespaceId, id, MAX_CHARGES);
+    }
+}
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemFood.java b/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
index 505f80cab..93a510a53 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemFood.java
@@ -15,7 +15,6 @@ public class ItemFood extends Item {
         this.healAmount = healAmount;
         this.ticksPerHeal = ticksPerHeal;
         this.isWolfsFavoriteMeat = favouriteWolfMeat;
-
         this.maxStackSize = maxStackSize;
     }
 
@@ -24,18 +23,17 @@ public class ItemFood extends Item {
         if(player.getHealth() < player.getMaxHealth()
             && player.getHealth() + player.getTotalHealingRemaining() < player.getMaxHealth()
             && selfStack.consumeItem(player)) {
-            player.eatFood(this);
-            world.playSoundAtEntity(player, player, this.ticksPerHeal >= 10 ? "random.bite_extended" : "random.bite", 0.5f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f, 1.1f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f);
+            player.eatFood(selfStack);
+            world.playSoundAtEntity(player, player, this.getTicksPerHeal(selfStack) >= 10 ? "random.bite_extended" : "random.bite", 0.5f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f, 1.1f + (itemRand.nextFloat() - itemRand.nextFloat()) * 0.1f);
         }
         return selfStack;
     }
 
-    public int getHealAmount()
-    {
+    public int getHealAmount(ItemStack stack) {
         return this.healAmount;
     }
 
-    public int getTicksPerHeal() {
+    public int getTicksPerHeal(ItemStack stack) {
         return this.ticksPerHeal;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
index 94adda0c5..acd647ec6 100644
--- a/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
+++ b/game/core/src/main/java/net/minecraft/core/item/ItemStack.java
@@ -20,6 +20,8 @@ import org.jetbrains.annotations.Nullable;
 
 import java.util.Objects;
 
+import static net.minecraft.core.world.save.conversion.ItemConverters.legacyBucketConverter;
+
 
 public final class ItemStack {
     public int stackSize;
@@ -405,6 +407,9 @@ public final class ItemStack {
         if(nbt == null) {
             return null;
         }
+
+        legacyBucketConverter(nbt);
+
         ItemStack stack = new ItemStack();
         stack.readFromNBT(nbt);
         if(stack.stackSize <= 0) {
@@ -486,4 +491,8 @@ public final class ItemStack {
         this.tag = tag;
 	}
 
+    public @NotNull ItemStack withTagValue(@NotNull String key, int value) {
+        this.tag.putInt(key, value);
+        return this;
+    }
 }
